diff --git a/src/formats.c b/src/formats.c
index 6a77e6473f..b46b174226 100644
--- a/src/formats.c
+++ b/src/formats.c
@@ -378,7 +378,8 @@ static char *fmt_self_test_body(struct fmt_main *format,
 	if (options.flags & FLG_NOTESTS) {
 		fmt_init(format);
 		dyna_salt_init(format);
-		format->methods.reset(db);
+		if (db)
+			format->methods.reset(db);
 		format->private.initialized = 2;
 		format->methods.clear_keys();
 		return NULL;
diff --git a/src/formats.h b/src/formats.h
index d8ceff0b2c..d510b22945 100644
--- a/src/formats.h
+++ b/src/formats.h
@@ -183,7 +183,8 @@ struct fmt_methods {
 
 /* Called whenever the set of password hashes being cracked changes, such as
  * after self-test, but before actual cracking starts.  When called before a
- * self-test or benchmark rather than before actual cracking, db may be NULL.
+ * self-test or benchmark rather than before actual cracking, db may be made
+ * out of test vectors.
  * Normally, this is a no-op since a format implementation shouldn't mess with
  * the database unnecessarily.  However, when there is a good reason to do so
  * this may e.g. transfer the salts and hashes onto a GPU card. */
diff --git a/src/john.c b/src/john.c
index 76b575e940..3b0c44faab 100644
--- a/src/john.c
+++ b/src/john.c
@@ -1611,8 +1611,9 @@ static void john_run(void)
 			struct db_main *test_db = 0;
 			char *where;
 
-			if ( (options.flags & FLG_NOTESTS) == 0)
-				test_db = ldr_init_test_db(database.format, &database);
+			if (!(options.flags & FLG_NOTESTS))
+				test_db = ldr_init_test_db(database.format,
+				                           &database);
 			where = fmt_self_test(database.format, test_db);
 			ldr_free_test_db(test_db);
 			if (where) {
